// refresh network list
program rnl;

{$APPTYPE CONSOLE}
uses
  SysUtils, windows, types;

type
  PGUID = ^TGUID;
  TGUID = packed record
  D1: LongWord;
  D2: Word;
  D3: Word;
  D4: array[0..7] of Byte;
end;

  PDot11_SSID = ^TDot11_SSID;
  TDot11_SSID = record
    uSSIDLength: ULONG;
    ucSSID: array [0..32] of UCHAR;
    end;

  WLAN_INTERFACE_INFO = record
    InterfaceGuid: TGUID;
    strInterfaceDescription: array [0..255] of widechar;
    isState: byte;
  end;

  PPWLAN_INTERFACE_INFO_LIST = ^PWLAN_INTERFACE_INFO_LIST;
  PWLAN_INTERFACE_INFO_LIST = ^WLAN_INTERFACE_INFO_LIST;
  WLAN_INTERFACE_INFO_LIST = record
    dwNumberOfItems, dwIndex: dword;
    InterfaceInfo: WLAN_INTERFACE_INFO;
    end;

function WlanOpenHandle(dwClientVersion: DWORD;
    pReserved: PBOOL; pdwNegotiatedVersion: PDWORD;
    phClientHandle: PHandle): DWORD; stdcall; external 'wlanapi.dll';

function WlanScan(hClientHandle: Thandle; pInterfaceGuid:PGUID;
    pDot11Ssid: PDot11_SSID; pIeData, preserved:pointer): DWORD; stdcall; external 'wlanapi.dll';

function WlanCloseHandle(hClientHandle: Thandle; preserved:pointer):DWORD; stdcall; external 'wlanapi.dll';

function WlanEnumInterfaces(hClientHandle: Thandle; preserved:pointer; ppInterfaceList: PPWLAN_INTERFACE_INFO_LIST):DWORD; stdcall; external 'wlanapi.dll';


  function rescan(): boolean;
  var
     r:DWORD;
     h:THandle;
     dwNegotiatedVersion: WORD;
     pInterfaceList: PWLAN_INTERFACE_INFO_LIST;
  begin
  result:=FALSE;
  r:=WlanOpenHandle(1,nil,@dwNegotiatedVersion,@h);
  if r <> 0 then exit;
  r:=WlanEnumInterfaces(h, NIL, @pInterfaceList);
  if r <> 0 then exit;
  if pInterfaceList.dwNumberOfItems <= 0 then exit;
  r:=WlanScan(h, @pInterfaceList.InterfaceInfo.InterfaceGuid,nil,nil,nil);
  if r <> 0 then exit;
  WlanCloseHandle(h,nil);
  result:=TRUE;
  end; // rescan

begin
write('Refresh Network List 1.0 beta1'#13#10'www.rejetto.com'#13#10#13#10'Requesting...');
if rescan() then writeln('done')
else writeln('failed');
end.
